"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.createResolverFromSource = createResolverFromSource;
const PermissionResolver_1 = require("./PermissionResolver");
/**
 * Create a PermissionResolver by loading rules from an external async source like a database.
 *
 * @param loader An async function that returns an array of PermissionRule objects.
 * @returns An instance of PermissionResolver
 */
async function createResolverFromSource(loader) {
    const rules = await loader();
    return new PermissionResolver_1.PermissionResolver(rules);
}
